from json import JSONEncoder
import json
from datetime import datetime
from iip.TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.RoutingCommand import RoutingCommand
from datatypes.RoutingCommandImpl import RoutingCommandImpl

class RoutingCommandEncoder(JSONEncoder):
    """JSON encoder class for RoutingCommand.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        return o.__dict__
    

class RoutingCommandSerializer(TypeTranslatorToString):
    """JSON transport serializer for RoutingCommand.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["RoutingCommand"] = self
        Registry.types[RoutingCommand] = "RoutingCommand"
        Registry.serializers["RoutingCommandImpl"] = self # there is a serializer for the Impl
        Registry.types[RoutingCommandImpl] = "RoutingCommand" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> RoutingCommand:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = RoutingCommandImpl()
        result.__dict__ = json.loads(data)
        return result

    def writeTo(self, source: RoutingCommand) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return RoutingCommandEncoder().encode(source).encode("UTF-8").decode()
        
RoutingCommandSerializer()
